package io.tswf.transmutations.expansion.exception

import groovy.transform.CompileStatic
import io.tswf.transmutations.expansion.meta.ExpansionMetadata
import org.objectweb.asm.tree.MethodNode

@CompileStatic
class ExpansionMetadataReadingException extends RuntimeException {
    ExpansionMetadata expansionMeta

    ExpansionMetadataReadingException(ExpansionMetadata expansionMeta) {
        super(getExceptionMessage("", expansionMeta))
        this.expansionMeta = expansionMeta
    }

    ExpansionMetadataReadingException(String message, ExpansionMetadata expansionMeta) {
        super(getExceptionMessage(message, expansionMeta))
        this.expansionMeta = expansionMeta
    }

    ExpansionMetadataReadingException(String message, Throwable cause, ExpansionMetadata expansionMeta) {
        super(getExceptionMessage(message, expansionMeta), cause)
        this.expansionMeta = expansionMeta
    }

    ExpansionMetadataReadingException(Throwable cause, ExpansionMetadata expansionMeta) {
        super(getExceptionMessage("", expansionMeta), cause)
        this.expansionMeta = expansionMeta
    }

    static String getExceptionMessage(String message, ExpansionMetadata expansionMeta) {
        return "Exception occurred while trying to read expansion class '${expansionMeta.expansionClass.javaName}': ${message}"
    }
}
