package io.tswf.transmutations.expansion.reader.exclusion

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.expansion.meta.ExpansionMetadata
import org.objectweb.asm.Type
import org.objectweb.asm.tree.MethodNode

@AutoService(IExpansionCustomExclusion)
@CompileStatic
class GroovyObjectCustomExclusion implements IExpansionCustomExclusion {

    @Override
    boolean isNeedsToExcludeMethod(ExpansionMetadata expansionMeta, MethodNode expansionMethodCandidate) {
        return expansionMethodCandidate.isMemberGroovyInternal(expansionMeta.expansionClass)
    }

    @Override
    boolean isNeedsToExcludeInterface(ExpansionMetadata expansionMeta, Type interfaceType) {
        return interfaceType == GroovyObject.asAsmType()
    }
}
